/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.ldt.shop.controller;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import org.apache.commons.lang3.ObjectUtils;
import org.springblade.common.aop.core.TenantAop;
import org.springblade.common.constant.Agent;
import org.springblade.common.constant.Salesman;
import org.springblade.core.boot.ctrl.BladeController;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.BladeUser;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.gateway.web_gateway.entity.vo.YeePayInfoVO;
import org.springblade.ldt.shop.dto.ArtificialWechatApplyDto;
import org.springblade.ldt.shop.entity.Shop;
import org.springblade.ldt.shop.service.IShopService;
import org.springblade.ldt.shop.vo.ShopVO;
import org.springblade.ldt.shop.vo.WechatConfigQueryVO;
import org.springblade.ldt.shop.wrapper.ShopWrapper;
import org.springblade.yeePay.entity.saas.InvitationDto;
import org.springblade.yeePay.entity.saas.MicroInvitationDto;
import org.springblade.yeePay.entity.saas.WechatApplyDto;
import org.springblade.yeePay.entity.saas.WechatConfigAddDto;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

/**
 * 控制器
 *
 * @author BladeX
 * @since 2021-09-23
 */
@RestController
@AllArgsConstructor
@RequestMapping("ldt_shop/shop")
@Api(value = "", tags = "接口")
public class ShopController extends BladeController {

	private final IShopService shopService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入shop")
	@TenantAop(salesman=Salesman.roleName)
	public R<ShopVO> detail(Shop shop, BladeUser bladeUser) {
		return R.data(ShopWrapper.build().entityVO(shopService.getOne(Condition.getQueryWrapper(shop))));
	}

	/**
	 * 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入shop")
	@TenantAop(salesman=Salesman.roleName)
	public R<IPage<ShopVO>> list(Shop shop, Query query, BladeUser bladeUser) {
		return R.data(ShopWrapper.build().pageVO(shopService.page(Condition.getPage(query), Condition.getQueryWrapper(shop))));
	}

	/**
	 * 获取代理的商户列表
	 */
	@GetMapping("/getAgentShopList")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "分页", notes = "传入agentUserId")
	@TenantAop(agent = Agent.roleName)
	public R<IPage<ShopVO>> getAgentShopList(Shop shop, Query query) {
		if (ObjectUtils.isEmpty(shop) || ObjectUtils.isEmpty(shop.getAgenter())) {
			return R.fail("缺少代理用户ID");
		}
		IPage<Shop> pages = shopService.page(Condition.getPage(query), Condition.getQueryWrapper(shop)
			.lambda()
			.select(Shop::getAgenter, Shop::getAgentAvatar, Shop::getAgentName, Shop::getName, Shop::getShopPic, Shop::getAddress, Shop::getLocation));
		return R.data(ShopWrapper.build().pageVO(pages));
	}

	/**
	 * 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入shop")
	public R<IPage<ShopVO>> page(ShopVO shop, Query query) {
		IPage<ShopVO> pages = shopService.selectShopPage(Condition.getPage(query), shop);
		return R.data(pages);
	}

	/**
	 * 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入shop")
	public R save(@Valid @RequestBody Shop shop) {
		return R.status(shopService.save(shop));
	}

	/**
	 * 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入shop")
	public R update(@Valid @RequestBody Shop shop) {
		return R.status(shopService.updateById(shop));
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入shop")
	public R submit(@Valid @RequestBody Shop shop) {
		return R.status(shopService.saveOrUpdate(shop));
	}


	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(shopService.deleteLogic(Func.toLongList(ids)));
	}

	@GetMapping("/getMerchantInfo")
	@ApiOperation(value = "易宝商户信息")
	public R<YeePayInfoVO> getMerchantInfo(Long shopId) {
		return R.data(shopService.getMerchantInfo(shopId));
	}

	@GetMapping("/getWechatConfigQuery")
	@ApiOperation(value = "商店公众号配置查询")
	public R<List<WechatConfigQueryVO>> getWechatConfigQuery(String businessId) {
		return shopService.getWechatConfigQuery(businessId);
	}

	@PostMapping("/wechatConfigAdd")
	@ApiOperation(value = "商店公众号配置")
	public R wechatConfigAdd(@RequestBody WechatConfigAddDto wechatConfigAddDto) {
		return shopService.wechatConfigAdd(wechatConfigAddDto);
	}

	@GetMapping("/getAuthStateQuery")
	@ApiOperation(value = "商户授权状态查询")
	public R getAuthStateQuery(String businessId) {
		return R.data(shopService.getAuthStateQuery(businessId));
	}

	@GetMapping("/getAuthAuditInfo")
	@ApiOperation(value = "微信实名认证信息")
	public R<WechatApplyDto> getAuthAuditInfo(String businessId) {
		return R.data(shopService.getAuthAuditInfo(businessId));
	}

	@PostMapping("/wechatApply")
	@ApiOperation(value = "微信实名认证申请")
	public R wechatApply(@RequestBody ArtificialWechatApplyDto artificialWechatApplyDto) {
		return R.data(shopService.wechatApply(artificialWechatApplyDto));
	}

	@PostMapping("/inviteMicro")
	@ApiOperation(value = "人工小微进件")
	public R inviteMicro(@RequestBody MicroInvitationDto microInvitationDto) {
		return R.data(shopService.inviteMicro(microInvitationDto));
	}

	@PostMapping("/invite")
	@ApiOperation(value = "人工商户进件")
	public R invite(@RequestBody InvitationDto invitationDto) {
		return R.data(shopService.inviteMerchant(invitationDto));
	}

}
